//main.h
#define MOTOR_DELAY 10	//5 for 20MHz, 10 for 40MHz
#define CHANNELS 8

#define Break_Detected	0	//; Break detected
#define Start_Detected	1	//; Start Byte detected
#define Valid_Channel	2	//; Reached valid channels

#define longcount	0	//; Long count flag (2.5s) when activated		
#define presetmode	1	//; Preset Mode on no DMX data
#define curve		2	//; S Curve selected
#define cswitch		3	//; Switch curve selected
#define DMX_Data	4	//; New DMX Data recieved
#define phase_done	5	//; Flag to show mains phase complete
#define dmx_error	6	//; Error detected in DMX tranmission
#define mains_fail	7	//; Maind Failure Flag


//---------------------------------------------------------------------
// Variable declarations
//---------------------------------------------------------------------
//Allocate buffers to databanks...
volatile union {
	struct {
		unsigned VALID_CHANNEL:1;
		unsigned START_DETECTED:1;
		unsigned BREAK_DETECTED:1;
		};
	unsigned char BYTE:8;
	} Iflag;
struct {
	unsigned DMX_DATA:1;
	unsigned DMX_ERROR:1;
	} Flag;
unsigned char flash;
unsigned char i;
unsigned char valid_data;
unsigned char valid_sc;
unsigned char valid_break;

unsigned char IH_Channels_Received;
unsigned int DMX_Start_Addr;
unsigned int IH_Channel_Counter;

#pragma udata page1=0x100
unsigned char diff;
unsigned char personality;
unsigned char Channel_Values[10];
unsigned char dmx_buffer[10];
unsigned char last_dmx[10];
unsigned char last_dmx_buffer[2];
unsigned char data_ready;

unsigned int int_value_pan;
unsigned int int_value_tilt;
unsigned int int_ptr;
unsigned char value_colour;
unsigned char value_gobo;
unsigned char value_shutter;
unsigned char value_iris;
unsigned char value_dimmer;
unsigned char pan_tilt_speed;
unsigned char dmx;
unsigned char last_dmx_val;
unsigned char motor_buffer[15];
unsigned long ltemp;
unsigned char dummy;
unsigned int int_scroll_colour;
#pragma udata page2=0x200

#pragma udata page3=0x300

#pragma udata page4=0x400

#pragma romdata
//---------------------------------------------------------------------
// Function Prototypes
//---------------------------------------------------------------------
void CheckUsart(void);
void isr_handler(void);
void init_irq(void);
void DisableInterrupts(void);
void EnableInterrupts(void);

void Read_Dip_Switches(void);
void Convert_DMX(void);
void set_pan_tilt_speed(void);
void Update_Motor_Board(void);
void Convert_Motor_Values(void);
void send_tx(unsigned char c);
void Update_Dimmer(void);
